Index: trunk/SophyaLib/BaseTools/srandgen.h
===================================================================
--- trunk/SophyaLib/BaseTools/srandgen.h	(revision 3614)
+++ trunk/SophyaLib/BaseTools/srandgen.h	(revision 3615)
@@ -1,5 +1,5 @@
-/* fonctions pour generateurs aleatoires     */
-/*                         cmv  23/06/94     */
-/*  R.Ansari 04/2000  Copie de nbrand.h .c   */
+/* fonctions pour generateurs aleatoires  cmv 23/06/94 */
+/*  Copie de nbrand.h .c  .Ansari 04/2000              */
+/* interface avec RandomGeneratorInterface cmv 04/2009 */
 
 #ifndef SRANDGEN_H_SEEN
@@ -8,80 +8,47 @@
 #include "machdefs.h"
 #include <stdlib.h>
+#include <complex>
+#include "randinterf.h"
 
-/* ------- SPECIFIQUE Mac Darwin OSX  <= 10.2 (gcc < 3.x) -------- */
-#if defined(Darwin) &&  defined(__GNUC__) && (__GNUC__ < 3)
-#include "osx_values.h"
-/* Declaration de drand48 et srand48 etc , mis ds SysSpec 
-                                          Reza 11/02/2003 */
-#ifdef __cplusplus
-extern "C" {
-#endif
-unsigned short int * seed48(unsigned short int seed16v[3]);
-void srand48(long seedval);
-/* Faute de mieux pour le moment : */
-#ifdef __cplusplus
-}
-#endif
-#define drand48() ((double)(random())/LONG_MAX)
-#endif
-/* ------- FIN SPECIFIQUE Mac OSX / Darwin V <= 10.2 --------- */
+/* Declaration en fonctions inline interface avec RandomGeneratorInterface global*/
 
-#ifdef __cplusplus
-/* Declaration en fonctions inlines pour du C++ */
-inline float frand01() { return ( (float) drand48() ); }
-inline double drand01() { return ( drand48() ); }
-inline double ranf01() { return ( drand48() ); }
+namespace SOPHYA {
 
-inline float frandpm1() { return ( 2. * (float) drand48()  - 1.); }
-inline double drandpm1() { return ( 2. * drand48() - 1.); }
-inline double ranfpm1() { return ( 2. * drand48() - 1.); }
-#else
-/* les memes en define pour du C */
-#define frand01() ( (float) drand48() )
-#define drand01() ( drand48() )
-#define ranf01() drand01()
 
-#define frandpm1() ( 2. * frand01() - 1.)
-#define drandpm1() ( 2. * drand01() - 1.)
-#define ranfpm1() drandpm1()
-#endif
+inline double drand01() 
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Flat01();}
+inline double drandpm1() 
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Flatpm1();}
 
-struct tirage_alea {
-  int Nbin;
-  double Min,Max,Lbin;
-  double *Tab;
-};
-typedef struct tirage_alea TIREALEA;
+inline double NorRand() 
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Gaussian();}
+inline double Gaussian(double sigma,double mu) 
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Gaussian(sigma,mu);}
 
-#ifdef __cplusplus
-extern "C" {
-#endif
+inline complex< r_8 > ComplexGaussian()
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->ComplexGaussian();}
+inline complex< r_8 > ComplexGaussian(double sig)
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->ComplexGaussian(sig);}
+inline double ModComplexGaussian(double sig=1.)
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->ModComplexGaussian(sig);}
 
-void Ini_Ranf_Quick(long seed_val, int lp);
-void Ini_Ranf(unsigned short seed_16v[3], int lp);
-void Get_Ranf(unsigned short seed_16v[3], int lp);
-void Auto_Ini_Ranf(int lp);
+inline double Poisson(double mu, double mumax=-1) 
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Poisson(mu,mumax);}
 
-void SetGauRange(double range);
-double NorRand1(void);
-double GauRnd1(double am, double s);
-double NorRand(void);
-double GauRnd(double am, double s);
-int NormCo(double *a,double *b
-          ,double mx,double my,double sx,double sy,double ro);
-void NormGau(double *x,double *y
-            ,double mx,double my,double sa,double sb,double teta);
+inline double Exponential() 
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Exponential();}
 
-int PoissRand(double mu);
-unsigned long PoissRandLimit(double mu,double mumax /* =10. */ );
+inline int Gaussian2DRho(double &x,double &y,double mx,double my,double sx,double sy,double ro)
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Gaussian2DRho(x,y,mx,my,sx,sy,ro);}
+inline void Gaussian2DAng(double &x,double &y,double mx,double my,double sa,double sb,double teta)
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->Gaussian2DAng(x,y,mx,my,sa,sb,teta);}
 
-TIREALEA *init_tirage_alea(int nbin,double xmin,double xmax,double (*fonc) (double));
-double tirage_alea(TIREALEA *alea);
-int end_tirage_alea(TIREALEA *alea);
+inline void AutoInitRand(int lp)
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->AutoInit(lp);}
 
-#ifdef __cplusplus
-}
-#endif
+inline void ShowRandom()
+  {return RandomGeneratorInterface::GetGlobalRandGenP()->ShowRandom();}
+
+}  /* namespace SOPHYA */
 
 #endif
-
Index: trunk/SophyaLib/BuildMgr/change_smake2make.csh
===================================================================
--- trunk/SophyaLib/BuildMgr/change_smake2make.csh	(revision 3614)
+++ trunk/SophyaLib/BuildMgr/change_smake2make.csh	(revision 3615)
@@ -10,5 +10,5 @@
 #--- Recherche des repertoires sous CVS
 if( $#argv > 0 ) then
-  set dcvs = $1
+  set dcvs = ( $* )
 else
   set dcvs =
Index: trunk/SophyaLib/HiStats/Makefile
===================================================================
--- trunk/SophyaLib/HiStats/Makefile	(revision 3614)
+++ trunk/SophyaLib/HiStats/Makefile	(revision 3615)
@@ -34,4 +34,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -63,4 +64,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -97,4 +99,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -132,4 +135,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -159,4 +163,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
@@ -186,4 +191,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
@@ -222,4 +228,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -262,4 +269,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -298,4 +306,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -371,4 +380,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
Index: trunk/SophyaLib/HiStats/smakefile
===================================================================
--- trunk/SophyaLib/HiStats/smakefile	(revision 3614)
+++ trunk/SophyaLib/HiStats/smakefile	(revision 3615)
@@ -34,4 +34,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -63,4 +64,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -97,4 +99,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -132,4 +135,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -159,4 +163,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
@@ -186,4 +191,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
@@ -222,4 +228,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -262,4 +269,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -298,4 +306,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -371,4 +380,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
Index: trunk/SophyaLib/Manual/Makefile
===================================================================
--- trunk/SophyaLib/Manual/Makefile	(revision 3614)
+++ trunk/SophyaLib/Manual/Makefile	(revision 3615)
@@ -6,10 +6,10 @@
 clean:
 	rm -rf *.o dox_filter
-	if [ -d /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual/ ] ; then cd /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual// ; rm -rf html latex man rtf; fi
+	if [ -d /home/local/SophyaWork/Linux/doc/ ] ; then cd /home/local/SophyaWork/Linux/doc// ; rm -rf html latex man rtf; fi
 
 #-------------------------------------------------------
 copy: 
-	if [ ! -d /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex ] ; then mkdir /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex; fi
-	cp -p *.tex *.sty *.eps *.inc /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/.
+	if [ ! -d /home/local/SophyaWork/Linux/doc//latex ] ; then mkdir /home/local/SophyaWork/Linux/doc//latex; fi
+	cp -p *.tex *.sty *.eps *.inc /home/local/SophyaWork/Linux/doc//latex/.
 
 #-------------------------------------------------------
@@ -25,8 +25,8 @@
 
 #-------------------------------------------------------
-sophya: copy /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/sophya.ps
+sophya: copy /home/local/SophyaWork/Linux/doc//latex/sophya.ps
 
-/home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/sophya.ps: sophya.tex defsophya.sty blue_sophya_400.eps ex1.inc
-	cd /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/; \
+/home/local/SophyaWork/Linux/doc//latex/sophya.ps: sophya.tex defsophya.sty blue_sophya_400.eps ex1.inc
+	cd /home/local/SophyaWork/Linux/doc//latex/; \
 	latex sophya.tex; \
 	makeindex sophya; \
@@ -34,8 +34,8 @@
 	dvips -o sophya.ps sophya.dvi
 
-piapp: copy /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/piapp.ps
+piapp: copy /home/local/SophyaWork/Linux/doc//latex/piapp.ps
 
-/home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/piapp.ps: piapp.tex piahelp.tex defsophya.sty
-	cd /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/; \
+/home/local/SophyaWork/Linux/doc//latex/piapp.ps: piapp.tex piahelp.tex defsophya.sty
+	cd /home/local/SophyaWork/Linux/doc//latex/; \
 	latex piapp.tex; \
 	makeindex piapp; \
@@ -43,8 +43,8 @@
 	dvips -o piapp.ps piapp.dvi
 
-pmixer: copy /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/pmixer.ps
+pmixer: copy /home/local/SophyaWork/Linux/doc//latex/pmixer.ps
 
-/home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/pmixer.ps: pmixer.tex
-	cd /home/manip/mnt/planck/cmv/SophyaWork/Linux/../Manual//latex/; \
+/home/local/SophyaWork/Linux/doc//latex/pmixer.ps: pmixer.tex
+	cd /home/local/SophyaWork/Linux/doc//latex/; \
 	latex pmixer.tex; \
 	latex pmixer; \
Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 3614)
+++ trunk/SophyaLib/NTools/Makefile	(revision 3615)
@@ -33,4 +33,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
@@ -67,4 +68,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
@@ -114,4 +116,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -120,11 +123,13 @@
  
 $(SOPHYAOBJP)dynccd.o: dynccd.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h fmath.h perandom.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h fmath.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)anydataobj.h perandom.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -146,6 +151,5 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)srandgen.h classfunc.h cimage.h \
+  $(SOPHYAINCP)tvector.h classfunc.h cimage.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)fioarr.h dynccd.h \
@@ -175,4 +179,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -207,4 +212,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -239,4 +245,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
@@ -266,4 +273,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
@@ -292,4 +300,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
@@ -319,4 +328,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -346,4 +356,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -378,4 +389,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -418,4 +430,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -458,4 +471,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -488,4 +502,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h cimage.h \
   $(SOPHYAINCP)fioarr.h \
@@ -512,10 +527,12 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)machdefs.h perandom.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)anydataobj.h perandom.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -537,6 +554,5 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)srandgen.h classfunc.h pemath.h
+  $(SOPHYAINCP)tvector.h classfunc.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  perandom.cc
  
@@ -564,4 +580,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -594,4 +611,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -629,4 +647,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generalfit.h \
@@ -680,4 +699,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
Index: trunk/SophyaLib/NTools/dynccd.cc
===================================================================
--- trunk/SophyaLib/NTools/dynccd.cc	(revision 3614)
+++ trunk/SophyaLib/NTools/dynccd.cc	(revision 3615)
@@ -5,4 +5,5 @@
 
 #include "fmath.h"
+#include "srandgen.h"
 #include "perandom.h"
 
Index: trunk/SophyaLib/NTools/perandom.cc
===================================================================
--- trunk/SophyaLib/NTools/perandom.cc	(revision 3614)
+++ trunk/SophyaLib/NTools/perandom.cc	(revision 3615)
@@ -1,8 +1,8 @@
 #include "sopnamsp.h"
 #include "machdefs.h"
+#include <iostream>
 #include "pexceptions.h"
+#include "srandgen.h"
 #include "perandom.h"
-#include "pemath.h"
-#include <iostream>
 
 
@@ -290,53 +290,2 @@
 }
 
-
-
-/////////////////////////////////////////////////////////////////
-/*
-**** Remarques sur complex< r_8 > ComplexGaussRan(double sig) ****
-
---- variables gaussiennes x,y independantes
-x gaussien: pdf f(x) = 1/(sqrt(2Pi) Sx) exp(-(x-Mx)^2/(2 Sx^2))
-y gaussien: pdf f(y) = 1/(sqrt(2Pi) Sy) exp(-(y-My)^2/(2 Sy^2))
-x,y independants --> pdf f(x,y) = f(x) f(y)
-On a:
-  <x>   = Integrate[x*f(x)]   = Mx
-  <x^2> = Integrate[x^2*f(x)] = Mx^2 + Sx^2
-
---- On cherche la pdf g(r,t) du module et de la phase
-  x = r cos(t) ,  y = r sin(t)
-  r=sqrt(x^2+y^2 , t=atan2(y,x)
-  (r,t) --> (x,y): le Jacobien = r
-
-  g(r,t) = r f(x,y) = r f(x) f(y)
-         = r/(2Pi Sx Sy) exp(-(x-Mx)^2/(2 Sx^2)) exp(-(y-My)^2/(2 Sy^2))
-
-- Le cas general est complique
-  (cf D.Pelat cours DEA "bruits et signaux" section 4.5)
-
-- Cas ou "Mx = My = 0" et "Sx = Sy = S"
-  c'est la pdf du module et de la phase d'un nombre complexe
-     dont les parties reelles et imaginaires sont independantes
-     et sont distribuees selon des gaussiennes de variance S^2
-  g(r,t) = r/(2Pi S^2) exp(-r^2/(2 S^2))
-  La distribution de "r" est donc:
-    g(r) = Integrate[g(r,t),{t,0,2Pi}]
-         = r/S^2 exp(-r^2/(2 S^2))
-  La distribution de "t" est donc:
-    g(t) = Integrate[g(r,t),{r,0,Infinity}]
-         = 1 / 2Pi  (distribution uniforme sur [0,2Pi[)
-  Les variables aleatoires r,t sont independantes:
-    g(r,t) = g(r) g(t)
-On a:
-  <r>   = Integrate[r*g(r)]   = sqrt(PI/2)*S
-  <r^2> = Integrate[r^2*g(r)] = 2*S^2
-  <r^3> = Integrate[r^3*g(r)] = 3*sqrt(PI/2)*S^3
-  <r^4> = Integrate[r^4*g(r)] = 8*S^4
-
-- Attention:
-La variable complexe "c = x+iy = r*exp(i*t)" ainsi definie verifie:
-              <|c|^2> = <c c*> = <x^2+y^2> = <r^2> = 2 S^2
-Si on veut generer une variable complexe gaussienne telle que
-     <c c*> = s^2 alors il faut prendre S = s/sqrt(2) comme argument
-
-*/
Index: trunk/SophyaLib/NTools/smakefile
===================================================================
--- trunk/SophyaLib/NTools/smakefile	(revision 3614)
+++ trunk/SophyaLib/NTools/smakefile	(revision 3615)
@@ -33,4 +33,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
@@ -67,4 +68,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
@@ -114,4 +116,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -120,11 +123,13 @@
  
 $(SOPHYAOBJP)dynccd.o: dynccd.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h fmath.h perandom.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h fmath.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)anydataobj.h perandom.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -146,6 +151,5 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)srandgen.h classfunc.h cimage.h \
+  $(SOPHYAINCP)tvector.h classfunc.h cimage.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)fioarr.h dynccd.h \
@@ -175,4 +179,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -207,4 +212,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -239,4 +245,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
@@ -266,4 +273,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
@@ -292,4 +300,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
@@ -319,4 +328,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -346,4 +356,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -378,4 +389,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -418,4 +430,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generaldata.h \
@@ -458,4 +471,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -488,4 +502,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h cimage.h \
   $(SOPHYAINCP)fioarr.h \
@@ -512,10 +527,12 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)machdefs.h perandom.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)anydataobj.h perandom.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
   $(SOPHYAINCP)mutyv.h \
   $(SOPHYAINCP)timestamp.h \
@@ -537,6 +554,5 @@
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)fmath.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)srandgen.h classfunc.h pemath.h
+  $(SOPHYAINCP)tvector.h classfunc.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  perandom.cc
  
@@ -564,4 +580,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -594,4 +611,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -629,4 +647,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h generalfit.h \
@@ -680,4 +699,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
Index: trunk/SophyaLib/Samba/Makefile
===================================================================
--- trunk/SophyaLib/Samba/Makefile	(revision 3614)
+++ trunk/SophyaLib/Samba/Makefile	(revision 3615)
@@ -12,26 +12,27 @@
  
 $(SOPHYAOBJP)alm.o: alm.cc $(SOPHYAINCP)sopnamsp.h alm.h \
-  $(SOPHYAINCP)stsrand.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
   $(SOPHYAINCP)triangmtx.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h
@@ -41,5 +42,7 @@
   $(SOPHYAINCP)fmath.h bruit.h \
   $(SOPHYAINCP)srandgen.h \
-  $(SOPHYAINCP)machdefs.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  bruit.cc
  
@@ -91,7 +94,8 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h alm.h \
-  $(SOPHYAINCP)stsrand.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
@@ -129,4 +133,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -195,4 +200,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -200,5 +206,5 @@
   $(SOPHYAINCP)fftpserver.h \
   $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)stsrand.h alm.h \
+  $(SOPHYAINCP)randinterf.h alm.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
Index: trunk/SophyaLib/Samba/smakefile
===================================================================
--- trunk/SophyaLib/Samba/smakefile	(revision 3614)
+++ trunk/SophyaLib/Samba/smakefile	(revision 3615)
@@ -12,26 +12,27 @@
  
 $(SOPHYAOBJP)alm.o: alm.cc $(SOPHYAINCP)sopnamsp.h alm.h \
-  $(SOPHYAINCP)stsrand.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
   $(SOPHYAINCP)triangmtx.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h
@@ -41,5 +42,7 @@
   $(SOPHYAINCP)fmath.h bruit.h \
   $(SOPHYAINCP)srandgen.h \
-  $(SOPHYAINCP)machdefs.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  bruit.cc
  
@@ -91,7 +94,8 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h alm.h \
-  $(SOPHYAINCP)stsrand.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
@@ -129,4 +133,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -195,4 +200,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -200,5 +206,5 @@
   $(SOPHYAINCP)fftpserver.h \
   $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)stsrand.h alm.h \
+  $(SOPHYAINCP)randinterf.h alm.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
